{$A-,B-,E-,F-,I-,N-,O-,R-,S+,V-}
{ PascalY. Edit Ycode tables. (c) 1989 YGP }
program EditTables;
  uses crt, DOS, machine,
       unit_edt,
       unit_scn,
       unit_str;

  const MaxMnemo  = 255;
	MaxLmnemo = 127;
	MaxSmnemo =  63;
	MaxRmnemo = 127;
	EntrScr = 18; { Entry Lines per screen }
	Fentry	= 6;  { First entry Y pos on screen }
	FName = 'mnemo.tbl';

  type InstrName = packed array [0..6] of char;
       MnemRec = record
	 Name: InstrName;
	 p: byte;
       end; { MnemRec }

  var i: integer;
      ch: char;
      Corrected: boolean;
      Err: word;
      Dir: DirStr;
      ParmNames: array [0..15] of string[4];

      Mnemo:  array [0.. MaxMnemo] of MnemRec;
      LMnemo: array [0..MaxLMnemo] of MnemRec;
      SMnemo: array [0..MaxSMnemo] of MnemRec;
      RMnemo: array [0..MaxRMnemo] of MnemRec;

      { descriptor byte: two nybbles
      {   0 - no parm,		1 - unsigned byte
      {   2 - double word,	3 - word
      {   4 - big,		5 - set
      {   6 - relative (word)
      {   7 - relative (byte+)	8 - relative (byte-)
      {   9 -			a - assembly (first nybble)
      {   b -			c -
      {   d -			e -

      {   f - Special (HiNybble)
      {    0 - LYCode		  1 - Std IO proc/func
      {    2 - Real		  3 -
      {    4 -			  5 -
      {    6 -			  7 -
      {    8 -			  9 -
      {    a -			  b -
      {    c -			  d -
      {    e -			  f -				}

  procedure WriteTables;
    var f: file;
  begin
  assign(f, dir + FName); rewrite(f, 1);
  if IOresult <> 0
    then begin write('Can''t open file ' + Dir + FName); halt; end;
  BlockWrite(f, Mnemo,	SizeOf(Mnemo));
  BlockWrite(f, LMnemo, SizeOf(LMnemo));
  BlockWrite(f, SMnemo, SizeOf(SMnemo));
  BlockWrite(f, RMnemo, SizeOf(RMnemo));
  if IOresult <> 0
    then begin write('Error writing file ' + Dir + FName); halt; end;
  close(f);
  end; { WriteTables }

  procedure ReadTables;
    var f: file;
  begin
  assign(f, dir + FName); reset(f, 1);
  if IOresult <> 0
    then begin write('Can''t open file ' + Dir + FName); halt; end;
  BlockRead(f, Mnemo,  SizeOf(Mnemo));
  BlockRead(f, LMnemo, SizeOf(LMnemo));
  BlockRead(f, SMnemo, SizeOf(SMnemo));
  BlockRead(f, RMnemo, SizeOf(RMnemo));
  if IOresult <> 0
    then begin write('Error reading file ' + Dir + FName); halt; end;
  close(f);
  end; { ReadTables }

  procedure EditTable(No: byte);
    label EndEdit;
    const EmptyName: array [1..4] of string[4] =
	    ('***_', 'LYC_', 'Std_', 'FP__');
	  HelpWalk = 'Clear, <cr> Edit, cursor keys, <esc> quit';
	  HelpEdit1 = 'Enter new name. <cr> accept, <esc> abort';
	  HelpEdit2 = 'esc, ins, del-No parm, Byte, Dwrd, Word, bIg, Set, Rel, rel+, rel-';
    type MnemoArray = array [0..0] of MnemRec;
	 MnemoPtr = ^MnemoArray;
    var CtrlEdt: _CtrlEdt;
	MinEntry, MaxEntry: word;
	Curr, Start: integer;
	Vmnemo: MnemoPtr;
	ch: char;
	w: word;
	Empty: string;

    procedure Put80chars(x,y: byte; s: string);
    begin
    __FastScn(x, y, @s[1], 80, 7, 0, _ChOnly_Scn);
    end; { Put80chars }

    procedure HiLight(x, y, size: byte);
    begin
    __WrAttScn(x, y, size, 0, 7);
    end; { HiLight }

    procedure LoLight(x, y, size: byte);
    begin
    __WrAttScn(x, y, size, 7, 0);
    end; { LoLight }

    procedure PutMnemo(x, y, No: word);
    begin
    GotoXY(x, y);
    with Vmnemo^[No] do
      begin write(Name, ' ');
      if HiNybble(p) = 0
	then begin write('': 9); exit end;
      write(ParmNames[HiNybble(p)]);
      if LoNybble(p) = 0
	then begin write('': 9 - length(ParmNames[HiNybble(p)])); exit end;
      write(',', ParmNames[LoNybble(p)],
	    '':9 - 1 - length(ParmNames[HiNybble(p)]) - length(ParmNames[LoNybble(p)]));
      end; { with }
    end; { PutMnemo }

    procedure ShowMnemo(Fmnemo: MnemoPtr; Strt: integer);
      procedure PutCode(x, y, b: byte);
      begin
      GotoXY(x, y); write(__ToHexStr(b, 1));
      end; { PutCode }

    begin { ShowMnemo }
    strt:= strt - strt mod 4;
    if strt + EntrScr * 4 > MaxEntry then strt:= MaxEntry + 1 - EntrScr * 4;
    if strt < 0 then strt:= 0;
    Start:= strt;
    while (strt <= MaxEntry) and (strt < Start + EntrScr * 4) do
      begin
      if strt mod 4 = 0
	then PutCode(2, Fentry + (strt - Start) div 4, MinEntry + strt);
      PutMnemo(6 +19*(strt mod 4), Fentry +(strt -Start) div 4, strt);
      Inc(Strt);
      end; { while }
    end; { ShowMnemo }

    function GetParm(var pp: byte; Hi: boolean): boolean;
      var ch: char;
	  p: byte;
    begin
    if Hi
      then p:= HiNybble(pp)
      else p:= LoNybble(pp);
    GetParm:= true;
    repeat ch:= UpCase(readkey);
      if ch = #0
	then case ReadKey of
	       #82: ch:= #13; { Ins }
	       #83: ch:= 'N'; { Del }
	       end;
    until ch in
      [#27, #13,    'N',     'B',  'D',  'W',   'I','S', 'R',    '+',  '-'];
    { 'esc, ins, del-No parm, Byte, Dwrd, Word, bIg, Set, Rel, rel+, rel-' }
    case ch of
      #27: GetParm:= false; { Don't change parameter(s) }
      #13: ;		    { Don't Change this parameter }
      'N': begin p:= 0;     { No more parameter(s) }
	   GetParm:= false;
	   end;
      'B': p:= 1;
      'D': p:= 2;
      'W': p:= 3;
      'I': p:= 4;
      'S': p:= 5;
      'R': p:= 6;
      '+': p:= 7;
      '-': p:= 8;
      end;
    if Hi
      then pp:= MakeByte(LoNybble(p), LoNybble(pp))
      else pp:= MakeByte(HiNybble(pp), LoNybble(p));
    end; { GetParm }

  begin { EditTable }
  __CoffScn(true); MinEntry:= 0;
  with CtrlEdt do
    begin _Col_edt:= 0; _Row_edt:= 0; _Len_Edt:= 7;
    _Fore_Edt:= 7; _Back_Edt:= 0;
    _RepCurs_Edt:= _Cbottom; _InsCurs_Edt:= _CLowBlock;
    _KeyProc_Edt:= nil; _EditMode_Edt:= _BeepOn_Edt;
    end; { CtrlEdt }
  if (No < 1) or (No > 4) then goto EndEdit;
  ClrScr;
  case No of
    1: begin MaxEntry:= MaxMnemo;
       Vmnemo:= @Mnemo;
       write('Ycode instructions':50);
       end; { when 1 }
    2: begin MaxEntry:= MaxLmnemo;
       Vmnemo:= @Lmnemo;
       write('Long Ycode instructions':48);
       end; { when 2 }
    3: begin MaxEntry:= MaxSmnemo;
       Vmnemo:= @Smnemo;
       write('Std proc/func names':50);
       end; { when 3 }
    4: begin MaxEntry:= MaxRmnemo; MinEntry:= $80; {   }
       Vmnemo:= @Rmnemo;
       write('FP instructions':50);
       end; { when 4 }
    end; { case }
  writeln;
  Put80chars(1, 2, '' +
		       '');
  Put80chars(1, 3, '   +00 = x0/x4/x8/xC +01 = x1/x5/x9/xD' +
		       ' +02 = x2/x6/xA/xE +03 = x3/x7/xB/xF');
  Put80chars(1, 4, '   name   parms      name   parms     ' +
		       ' name   parms      name   parms     ');
  Put80chars(1, 5, '' +
		       '');
  for w:= 6 to 23 do
    Put80chars(1, w, '                                      ' +
			 '                                    ');

  Put80chars(1, 24,'' +
		       '');
  GotoXY(1, 25); write(HelpWalk); ClrEol;
  ShowMnemo(Vmnemo, 0); Curr:= Start;
  repeat HiLight(5+19*(Curr mod 4), Fentry + (Curr - Start) div 4, 18);
    ch:= ReadKey; LoLight(5+19*(Curr mod 4), Fentry+(Curr-Start) div 4, 18);
    case ch of
      #0: case ReadKey of
	    #71: { Home }
	      begin Curr:= 0;
	      if Start > 0
		then ShowMnemo(Vmnemo, 0);
	      end;

	    #72: { Up }
	      begin
	      if Curr > 3
		then begin Dec(Curr, 4);
		     if Curr < Start
		       then ShowMnemo(Vmnemo, Curr);
		     end;
	      end;

	    #73: { PgUp }
	      ;
	    #75: { Left }
	      begin
	      if Curr > 0
		then begin Dec(Curr);
		     if Curr < Start
		       then ShowMnemo(Vmnemo, Curr);
		     end;
	      end;

	    #77: { Right }
	      begin
	      if Curr < MaxEntry
		then begin Inc(Curr);
		     if Curr >= Start + EntrScr * 4
		       then ShowMnemo(Vmnemo, Curr);
		     end;
	      end;

	    #79: { End }
	      begin Curr:= MaxEntry;
	      if Start + EntrScr * 4 < MaxEntry
		then ShowMnemo(Vmnemo, MaxEntry);
	      end;

	    #80: { Down }
	      begin
	      if Curr < MaxEntry - 3
		then begin Inc(Curr, 4);
		     if Curr >= Start + EntrScr * 4
		       then ShowMnemo(Vmnemo, Curr);
		     end;
	      end;

	    #81: { PgDn }
	      ;
	    end; { case }
      'c', 'C': begin Empty:= EmptyName[No] + __ToHexStr(Curr+MinEntry, 1);
		Vmnemo^[Curr].Name:= '       ';
		Move(Empty[1], Vmnemo^[Curr].Name, length(Empty));
		Vmnemo^[Curr].p:= 0;
		PutMnemo(6+19*(Curr mod 4), Fentry+(Curr-Start) div 4, Curr);
		Corrected:= true;
		end; { when clear }
      #13,
      'e', 'E': begin GotoXY (1, 25); write(HelpEdit1); ClrEol;
		GotoXY(6+19*(Curr mod 4), Fentry+(Curr-Start) div 4);
		__CoffScn(false);
		__EnterEdt(Vmnemo^[Curr].Name, Empty, CtrlEdt, Err);
		__CoffScn(true);
		if err = 0
		  then begin Vmnemo^[Curr].Name:= '       ';
		       Move(Empty[1], Vmnemo^[Curr].Name, length(Empty));
		       Corrected:= true;
		       PutMnemo(6+19*(Curr mod 4),
				Fentry+(Curr-Start) div 4,
				Curr);
		       GotoXY(1, 25); write('First parm: ', HelpEdit2); ClrEol;
		       if GetParm(Vmnemo^[Curr].p, true)
			 then begin GotoXY(1, 25);
			      write('Second parm: ', HelpEdit2); ClrEol;
			      PutMnemo(6+19*(Curr mod 4),
				       Fentry+(Curr-Start) div 4,
				       Curr);
			      if GetParm(Vmnemo^[Curr].p, false) then ;
			      end;
		       PutMnemo(6+19*(Curr mod 4),
				Fentry+(Curr-Start) div 4,
				Curr);
		       end;
		GotoXY (1, 25); write(HelpWalk); ClrEol;
		end;
      #27: goto EndEdit;
      end; { case }
  until false;
  EndEdit:
  __CoffScn(false);
  end; { EditTable }

  procedure InitParmNames;
    var i: byte;
  begin
  for i:= 0 to 15 do
    ParmNames[i]:= #7 + __ToHexStr(i, 1) +'?';
  ParmNames[1]:= 'byte'; ParmNames[2]:= 'Dwrd'; ParmNames[3]:= 'word';
  ParmNames[4]:= 'big';  ParmNames[5]:= 'set';  ParmNames[6]:= 'rel';
  ParmNames[7]:= 'rel+'; ParmNames[8]:= 'rel-';

  ParmNames[$a]:= 'ASM';   ParmNames[$f]:= 'spec';
  end; { InitParmNames }

  var DOSname: NameStr;
      DOSext:  ExtStr;
begin
InitParmNames; Corrected:= false;
FSplit(ParamStr(0), Dir, DOSname, DOSext);
ReadTables;
repeat ClrScr;
  writeln('Enter Your selection:');
  writeln('  0) Quit');
  writeln('  1) Edit Ycode instruction mnemonics.');
  writeln('  2) Edit Long Ycode mnemonics');
  writeln('  3) Edit Std proc/func names');
  writeln('  4) Edit Real (FP) instructions');
  repeat readln(i);
  until i < 5;
  EditTable(i);
until i = 0;

if Corrected
  then begin if IOresult = 0 then ;
       GotoXY(1,25); ClrEol;
       write('Update changes? (Y/N)');
       repeat ch:= UpCase(ReadKey);
	 if (ch = #0) and (ReadKey = #0) then ; { flush boza }
       until ch in ['Y', 'N'];
       if ch = 'Y'
	 then WriteTables;
       end;
end.
